#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <fcntl.h>
#include <unistd.h>
#include <ctype.h>
#include <qdos.h>
#include <qptr.h>

#define LINES   14
#define COLUMNS 50
#define BORDERW 1
#undef _condetails
struct WINDOWDEF _condetails = {
                             2,
                             BORDERW,
                             0,
                             7,
                             6*COLUMNS+4*BORDERW,
                             10*LINES+3*BORDERW+12,
                             16,
                             26
                            };
struct INDEX_ENTRY{
char    type;
char    spare;
short   zone;
short   net;
long    filepos;
};
void    consetup_title();
void    (*_consetup)() = consetup_title;
long    (*_cmdchannels)() = NULL;
char    *_endmsg = NULL;

char    _prog_name[] = "ViewNL";
char    _version[]   = "v1.02";
char    _copyright[] = "PA Borman, May 95";

void    goodbye(int,int);
void    menu(void);
void    zones(void);
void    nets(void);
void    nodes(void);
void    fullnr(void);
int     show_it(char *,char *,short,short,short);

  FILE *nl;
  int   ix;
  char output[100];
  short zone = 2;
  short net  = 0;
  char  keypress;
  long  idxbase;
  struct INDEX_ENTRY idx;

int  main(int argc, char * argv[], char * argp[])
{
  char nodelist[36];
  char nlindex[36];
  char entry[200];
  char *c;
  char *tokptr;
  int  b;

  if (argc > 2 )
    {
      printf("usage: nlistindex\n");
      goodbye(-1,4);
    }
  if (argc == 2 )
    strcpy(nlindex,argv[1]);
  else
  {
    printf("NlistIndex -> ");
    tokptr = fgets(&nlindex[0], 36, stdin);
    if(tokptr == NULL)
      return(-15);
  }
  tokptr += strlen(nlindex);
  tokptr --;                    /* if last char of name */
  if(*tokptr == '\n')           /* is a newline, strip it off */
     *tokptr = '\0';

  ix = open(nlindex,O_RDONLY,0);
  if (ix != -1 )
  {
    c = nodelist;
    *c = '\0';
    b = 0;
    while(b < 36)
    {
      (void)read(ix, c, 1);
      if (*c == '\n')
        break;
      c++;
      b++;
    }
    *c = '\0';

    idxbase = lseek(ix, 0, 1);          /* get current offset for index base */

    nl = fopen(nodelist, "r");
    if ( nl != NULL )
    {
      while(1)
      {
        menu();
        if( keypress == 'E')
        {
          goodbye(0,1);
        }
        if( keypress == 'Z')
          zones();
        if( keypress == 'N')
          nets();
        if( keypress == 'S')
          nodes();
        if( keypress == 'F')
          fullnr();
      }
    }
    else
    {
      printf("Unable to open \"%s\"\n",nodelist);
      goodbye(-1,4);
    }
  }
  else
  {
    printf("Unable to open \"%s\"\n",nlindex);
    goodbye(-1,4);
  }
}
void goodbye(int exit_code, int delay)
{
   if( nl != NULL)
     fclose(nl);
   if( ix != -1);
     close(ix);
   sleep(delay);
   exit(exit_code);
}
void menu(void)
{
char key;
  sd_clear( getchid( fileno(stdout)), -1);
  printf("Current settings are:   Zone %d   Net %d\n",zone,net);
  printf("Change [Z]one or [N]et, [S]how node details\n[F]ull zone:net/node, or [E]xit\n");
  read(0, &key, 1);
  keypress = toupper(key);
}
void fullnr(void)
{
char answer[200];
char *tokptr;
char *statptr;
short tzone,tnet,tnode;
int ok;

  printf("\bZone:net/node to look for, eg 2:2503/402\n");
  if( fgets(answer,20,stdin) != NULL)
  {
    tokptr = strchr(&answer[0], ':');
    if (tokptr == NULL)
    {
      puts("Bad zone");
      return();
    }
    tzone = (short)atoi(&answer[0]);
    tnet  = (short)atoi(tokptr+1);
    tokptr = strchr(tokptr, '/');
    if (tokptr == NULL)
    {
      puts("Bad net");
      return();
    }
    tnode = (short)atoi(tokptr+1);

    lseek(ix, idxbase, 0);

      idx.zone = 0;
      idx.net  = 0;
      while( (idx.zone != tzone) || (idx.net != tnet) )
      {
         if (read(ix, &idx, sizeof(idx)) != sizeof(idx))
         {
           printf("Index access error\n");
           sleep(4);
           return();
         }
      }
      fseek(nl, idx.filepos, SEEK_SET);
      fgets(answer, 200, nl);                   /* read host line */
      if(tnode == 0)
      {
         statptr = strtok(answer, ",");
         tokptr  = strtok(NULL, ",");
         ok = show_it(answer,statptr,tzone,tnet,tnode);
      }
      else
      {
        ok = 1;
        while(ok == 1)
        {
          if( fgets(answer, 200, nl) == NULL )
             ok = 0;
          if( strstr(answer, ",") == answer)
            tokptr = strtok(answer, ",");
          else
          {
            if( strstr(answer,"Zone") == answer)  /* start of new zone */
               ok = 0;
            if( strstr(answer,"Host") == answer)  /* start of new net */
               ok = 0;
            statptr = strtok(answer, ",");
            tokptr  = strtok(NULL, ",");
          }
          if( ok && (tokptr != NULL))
          {
            if( tnode == (short) atoi(tokptr))
            {
              ok = show_it(answer,statptr,tzone,tnet,tnode);
            }
          }
        }
      }
      if(ok == 0)
        printf("Node %4.4d could not be found\n",tnode);
      sleep(4);
      return();
  }
}
void zones(void)
{
char answer[200];
char *tokptr;
char count;

  printf("\bZone number, ? to list zones,\nor hit return for no change\n");
  if( fgets(answer,10,stdin) != NULL)
  {
    if( answer[0] == '?')
    {
      lseek(ix, idxbase, 0);
      count = 0;
      while( read(ix, &idx, sizeof(idx)) == sizeof(idx))
      {
        if( idx.type == 'Z')
        {
          fseek(nl, idx.filepos, SEEK_SET);
          fgets(answer, 200, nl);
          tokptr = strtok(answer, ",");
          idx.zone = (short)atoi(strtok(NULL, ","));
          printf("Zone %d %s\n", idx.zone, strtok(NULL, ","));
          count++;
          if(count == 12)
          {
            sleep(2);
            count = 0;
          }
        }
      }
      sleep(4);
      return();
    }
    if( strlen(answer) > 1 )
      zone = (short)atoi(answer);
  }
}
void nets(void)
{
char answer[200];
char *tokptr;
char count;

  printf("\bNet number, ? to list nets,\nor hit return for no change\n");
  if( fgets(answer,10,stdin) != NULL)
  {
    if( answer[0] == '?')
    {
      lseek(ix, idxbase, 0);
      idx.zone = 0;
      idx.net  = 0;
      while( idx.zone != zone)
      {
         if (read(ix, &idx, sizeof(idx)) != sizeof(idx))
         {
           printf("Index access error\n");
           sleep(4);
           return();
         }
      }
      fseek(nl, idx.filepos, SEEK_SET);
      fgets(answer, 200, nl);
      tokptr = strtok(answer, ",");
      tokptr = strtok(NULL, ",");
      printf("Zone %d, %s\n", idx.zone, strtok(NULL, ","));
      count = 1;
      while( read(ix, &idx, sizeof(idx)) == sizeof(idx))
      {
        if( idx.zone == zone)
        {
          fseek(nl, idx.filepos, SEEK_SET);
          fgets(answer, 200, nl);
          tokptr = strtok(answer, ",");
          tokptr = strtok(NULL, ",");
          idx.net = (short)atoi(tokptr);
          printf("    %4.4d %s\n", idx.net, strtok(NULL, ","));
          count++;
          if(count == 12)
          {
            sleep(2);
            count = 0;
          }
        }
        else
        {
          sleep(4);
          return();
        }
      }
    }
    if( strlen(answer) > 1 )
      net = (short) atoi(answer);
  }
}
int show_it(char *ans,char *stat,short tzn,short tnt,short tnd)
{
char speeds[100];
char other[100];
char *tokptr;
int ok;
            printf("\nZone        %d\nNet         %d\n",tzn,tnt);
            printf("Node        %d\nName        %s\n",tnd,strtok(NULL, ","));
            if( strstr(ans, ",") == ans)
              printf("Status      Normal\n");
            else
              printf("Status      %s\n",stat);
            printf("Sysop       %s\nLocation    %s\n",strtok(NULL, ","),
                    strtok(NULL, ","));
            printf("Phone       %s\n",strtok(NULL, ","));
            speeds[0] = '\0';
            other[0]  = '\0';
            while((tokptr = strtok(NULL, ",\n\r")) != NULL)
            {
               ok = 1;
               if( strstr(tokptr, "CM") == tokptr)
               {
                 strcat(other,"24 hour mail,");
                 ok = 0;
               }
               if( strstr(tokptr, "MO") == tokptr)
               {
                 strcat(other,"Mail only,");
                 ok = 0;
               }
               if( strstr(tokptr, "LO") == tokptr)
               {
                 strcat(other,"Listed nodes only,");
                 ok = 0;
               }
               if( strstr(tokptr, "MN") == tokptr)
               {
                 strcat(other,"No compressed mail,");
                 ok = 0;
               }
               if( strstr(tokptr, "XA") == tokptr)
               {
                 strcat(other,"Bark & Wazoo,");
                 ok = 0;
               }
               if( strstr(tokptr, "XB") == tokptr)
               {
                 strcat(other,"Bark & Wazoo, no Wazoo updates,");
                 ok = 0;
               }
               if( strstr(tokptr, "XC") == tokptr)
               {
                 strcat(other,"Bark & Wazoo, no Bark updates,");
                 ok = 0;
               }
               if( strstr(tokptr, "XP") == tokptr)
               {
                 strcat(other,"Bark only,");
                 ok = 0;
               }
               if( strstr(tokptr, "XR") == tokptr)
               {
                 strcat(other,"Bark & Wazoo, no updates,");
                 ok = 0;
               }
               if( strstr(tokptr, "XW") == tokptr)
               {
                 strcat(other,"Wazoo only, no updates,");
                 ok = 0;
               }
               if( strstr(tokptr, "XX") == tokptr)
               {
                 strcat(other,"Wazoo only,");
                 ok = 0;
               }
               if( strstr(tokptr, "G") == tokptr)
               {
                 strcat(other,"Gate to ");
                 strcat(other,tokptr+1);
                 strcat(other,",");
                 ok = 0;
               }
               if( strstr(tokptr, "#") == tokptr)
               {
                 strcat(other,"Mail hour ");
                 strcat(other,tokptr+1);
                 strcat(other,",");
                 ok = 0;
               }
               if( strstr(tokptr, "U") == tokptr)
               {
                 strcat(other,"U:");
                 strcat(other,tokptr+1);
                 while((tokptr = strtok(NULL, ",\n\r")) != NULL)
                 {
                   strcat(other,tokptr);
                   strcat(other," ");
                 }
                 strcat(other,",");
                 ok = 0;
               }
               if( ok)
               {
                 strcat(speeds,tokptr);
                 strcat(speeds,",");
               }
            }
            speeds[strlen(speeds)-1] = '\0';
            printf("Speeds      %s\n",speeds);
            other[strlen(other)-1] = '\0';
            printf("Flags       %s\n\n",other);
            ok = 2;
            return(ok);
}
void nodes(void)
{
char answer[200];
char *tokptr;
char *statptr;
char ok = 1;
short node;
char count;

  printf("\bNode number, ? to list nodes,\nor hit return for no listing\n");
  if( fgets(answer,10,stdin) != NULL)
  {
    if( answer[0] == '?')
    {
      lseek(ix, idxbase, 0);
      idx.zone = 0;
      idx.net  = 0;
      while( (idx.zone != zone) || (idx.net != net) )
      {
         if (read(ix, &idx, sizeof(idx)) != sizeof(idx))
         {
           printf("Index access error\n");
           sleep(4);
           return();
         }
      }
      fseek(nl, idx.filepos, SEEK_SET);
      fgets(answer, 200, nl);
      tokptr = strtok(answer, ",");
      tokptr = strtok(NULL, ",");
      printf("Zone %d, Net %4.4d %s\n", zone, net, strtok(NULL, ","));
      ok = 1;
      count = 1;
      while(ok)
      {
        if( fgets(answer, 200, nl) == NULL )
           ok = 0;
        if( strstr(answer, ",") == answer)
          tokptr = strtok(answer, ",");
        else
        {
          if( strstr(answer,"Zone") == answer)
             ok = 0;
          if( strstr(answer,"Host") == answer)
             ok = 0;
          tokptr = strtok(answer, ",");
          tokptr = strtok(NULL, ",");
        }
        if( ok && (tokptr != NULL))
        {
          printf("    %4.4d %s\n", (short)atoi(tokptr), strtok(NULL, ","));
          count++;
          if(count == 12)
          {
            sleep(2);
            count = 0;
          }
        }
      }
      sleep(4);
      return();
    }
    if( strlen(answer) > 1 )
    {
      node = (short) atoi(answer);
      lseek(ix, idxbase, 0);
      idx.zone = 0;
      idx.net  = 0;
      while( (idx.zone != zone) || (idx.net != net) )
      {
         if (read(ix, &idx, sizeof(idx)) != sizeof(idx))
         {
           printf("Index access error\n");
           sleep(4);
           return();
         }
      }
      fseek(nl, idx.filepos, SEEK_SET);
      fgets(answer, 200, nl);
      ok = 1;
      while(ok == 1)
      {
        if( fgets(answer, 200, nl) == NULL )
           ok = 0;
        if( strstr(answer, ",") == answer)
          tokptr = strtok(answer, ",");
        else
        {
          if( strstr(answer,"Zone") == answer)
             ok = 0;
          if( strstr(answer,"Host") == answer)
             ok = 0;
          statptr = strtok(answer, ",");
          tokptr  = strtok(NULL, ",");
        }
        if( ok && (tokptr != NULL))
        {
          if( node == (short) atoi(tokptr))
          {
            ok = show_it(answer,statptr,zone,net,node);
          }
        }
      }
      if(ok == 0)
        printf("Node %4.4d could not be found\n",node);
      sleep(4);
      return();
    }
  }
}
